/* Insert header here. */
#ifndef __GSK_DAEMON_SETTINGS_H_
#define __GSK_DAEMON_SETTINGS_H_


typedef struct _GskDaemonSettings GskDaemonSettings;
typedef struct _GskDaemonSettingsClass GskDaemonSettingsClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "gskgtk.h"

/* --- type macros --- */
GtkType gsk_daemon_settings_get_type();
#define GSK_TYPE_DAEMON_SETTINGS			(gsk_daemon_settings_get_type ())
#define GSK_DAEMON_SETTINGS(obj)              (GTK_CHECK_CAST ((obj), GSK_TYPE_DAEMON_SETTINGS, GskDaemonSettings))
#define GSK_DAEMON_SETTINGS_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GSK_TYPE_DAEMON_SETTINGS, GskDaemonSettingsClass))
#define GSK_DAEMON_SETTINGS_GET_CLASS(obj)    (GSK_DAEMON_SETTINGS_CLASS(GTK_OBJECT(obj)->klass))
#define GSK_IS_DAEMON_SETTINGS(obj)           (GTK_CHECK_TYPE ((obj), GSK_TYPE_DAEMON_SETTINGS))
#define GSK_IS_DAEMON_SETTINGS_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GSK_TYPE_DAEMON_SETTINGS))

/* --- structures --- */
struct _GskDaemonSettingsClass {
  GtkObjectClass		object_class;
};
struct _GskDaemonSettings {
  GtkObject		object;

  char                 *user;
  char                 *group;
  char                 *chroot;
  char                 *logfile;
  gboolean              niceness_valid;
  int                   niceness;
};

/* --- prototypes --- */
void gsk_daemon_settings_go (GskDaemonSettings *setting);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
