#ifndef __GSK_LISP_NAMESPACE_GLOBAL__H_
#define __GSK_LISP_NAMESPACE_GLOBAL__H_

#include "gsklispnamespace.h"

/* The global namespace defines the following primitives:
 *
 *    (define NAME ARGS RETURN-TYPE EXPR)
 *    (value NAME)
 *    (let NAME TYPE EXPR)
 *
 * And the following numerical functions:
 *    (int-to-double INT)		[double]
 *    (double-to-int DOUBLE)		[int]
 *    (int-less-than INT INT)		[boolean]
 *    (int-greater-than INT INT)	[boolean]
 *    (int-less-eq INT INT)		[boolean]
 *    (int-greater-eq INT INT)		[boolean]
 *    (int-eq INT INT)			[boolean]
 *    (int-sum INT ...)			[int]
 *    (int-product INT ...)		[int]
 *    (int-divide NUM DENOM)		[int]
 *    (int-modulus NUM DENOM)		[int]
 *    (not BOOLEAN)			[boolean]
 */
GskLispNamespace *gsk_lisp_namespace_ref_global();


#endif
